//+------------------------------------------------------------------+
//|                                                         alma.mq4 |
//|                                              converted by mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

enum en_prices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};

extern int       AlmaPeriod       = 14;
extern double    AlmaSigma        = 6.0;
extern double    AlmaSample       = 0.25;
extern en_prices AlmaPrice        = pr_close;
extern bool      alertsOn         = true;
extern bool      alertsOnCurrent  = false;
extern bool      alertsMessage    = true;
extern bool      alertsSound      = true;
extern bool      alertsEmail      = false;
extern bool      alertsNotify     = false;
extern string    soundFile        = "alert2.wav";
extern bool      arrowsVisible    = true;
extern string    arrowsIdentifier = "alma Arrows1";
extern double    arrowsUpperGap   = 0.5;
extern double    arrowsLowerGap   = 0.5;
extern color     arrowsUpColor    = DeepSkyBlue;
extern color     arrowsDnColor    = Red;
extern int       arrowsUpCode     = 233;
extern int       arrowsDnCode     = 234;
extern int       arrowsUpSize     = 1;
extern int       arrowsDnSize     = 1;

//
//
//
//
//

double Alma[];
double Almada[];
double Almadb[];
double slope[];
double coeffs[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,Almada); SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,Almadb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Alma);
   SetIndexBuffer(3,slope);
   
   //
   //
   //
   //
   //
   
      AlmaPeriod = MathMax(AlmaPeriod,1);
      ArrayResize(coeffs,AlmaPeriod);
      
         double m = MathFloor(AlmaSample * (AlmaPeriod - 1.0));
         double s = AlmaPeriod/AlmaSigma;
         for (int i=0; i<AlmaPeriod; i++)
            coeffs[i] = MathExp(-((i-m)*(i-m))/(2.0*s*s));

   //
   //
   //
   //
   //
         
   IndicatorShortName("Alma ("+AlmaPeriod+","+DoubleToStr(AlmaSigma,2)+","+DoubleToStr(AlmaSample,2)+")");
   return(0);
}
int deinit() 
{ 
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
	for(int i = limit; i >= 0; i--)
   {
      double sum=0;
      double div=0;
      for (int k=0; k<AlmaPeriod && (k+i)<Bars; k++)
      {
         sum += coeffs[k]*iMA(NULL,0,1,0,MODE_SMA,(int)AlmaPrice,i+k);
         div += coeffs[k];
      }
      
      //
      //
      //
      //
      //
      
      Almada[i] = EMPTY_VALUE;
      Almadb[i] = EMPTY_VALUE;
      if (div!=0)
            Alma[i] = sum/div;
      else  Alma[i] = 0;       
      slope[i] = slope[i+1];
      if (Alma[i]>Alma[i+1]) slope[i] =  1;
      if (Alma[i]<Alma[i+1]) slope[i] = -1;
      if (slope[i]== 1) Almada[i] = 1;
      if (slope[i]==-1) Almadb[i] = 1;
      
      //
      //
      //
      //
      //
      
      if (arrowsVisible)
      {
        ObjectDelete(arrowsIdentifier+":"+Time[i]);
        if (slope[i] != slope[i+1])
        {
          if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
          if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
        }
      
       }
   }
   
   //
   //
   //
   //
   //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (slope[whichBar] != slope[whichBar+1])
      if (slope[whichBar] == 1)
            doAlert("sloping up");
      else  doAlert("sloping down");       
    }
   return(0);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+ arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - arrowsLowerGap * gap);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Alma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Alma "),message);
             if (alertsNotify)  SendNotification(message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

